/*
 * device.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef device_h
#define device_h


#include<types.h>
#include<proc.h>


#ifndef ASM_FILE


enum{
	/* ǥХ̡ */
	DEV_CLASS_BLOCK=0,		/* ֥åǥХ */
	DEV_CLASS_CHARA,		/* 饯ǥХ */
	DEV_CLASS_NETWORK,		/* ͥåȥǥХ */
};


// Ԥѹ¤
typedef struct WAIT_INTR{
	PROC *proc;		// Ԥץ
	int isDel;		// ץ塼뤫Ǥ³Ȥ˥ץ塼ꤹ롣
	int lock;		// ԥåȡ
}WAIT_INTR;

// Ԥץꤹ˳ߤȯȤꤵ͡
#define WAIT_INTR_ACCESS ((PROC*)-1)


#define DEV_FS_NAME "devFs"

/* ʪǥХȤ */
typedef struct DEV_INFO{
	const char *name;					/* Device name */
	int sector_size;					/* Secter size */
	uint begin_blk;						/* Begin block number */
	uint last_blk;						/* Last block number */
	int (*open)();						/*  */
	int (*close)();						/*  */
	int (*read)(void*,size_t,size_t);	/* parameters : Buffer,transfer blocks,Begin block number */
	int (*write)(void*,size_t,size_t);	/* parameters : Buffer,transfer blocks,Begin block number */
	int (*ioctl)(int,...);				/* parameters : Comand */
	int (*select)(int,int);				/* parameters : ioμflag,polling flag */
	void *linf;							/* Device local infomation address. */
	struct DEV_INFO *next;
}DEV_INFO;

/* ǥХơȹ¤Ρ */
typedef struct{
	uchar       prt_type;		/* ѡƥ󥿥 */
	uchar       prt_num;		/* ѡƥʥС */
	ushort      sect_size;		/*  */
	uint        all_sect;		/*  */
	const char *name;
}DEV_STAT;


extern void wait_intr(WAIT_INTR*,uint,int);
//extern void wake_intr(WAIT_INTR*,int);
extern int wake_intr(WAIT_INTR*,int);
extern int initDeviceFs();
extern int initBlockCache();
extern int mountDeviceFs();
extern int regist_device(DEV_INFO*);
extern int registBlockPartition(const char*);
extern int delete_device(const char*);
extern int get_devstat(int,DEV_STAT*);
extern int sys_sync();
extern int read_direct(int,void*,size_t,size_t);
extern int write_direct(int,void*,size_t,size_t);
extern int read_cache(int,void*,size_t,size_t);
extern int write_cache(int,void*,size_t,size_t);
extern int sys_ttyname(int,char*);


#endif


#endif
