/*
 * Device tables which are exported to userspace via
 * scripts/table2alias.c.  You must keep that file in sync with this
 * header.
 */

#ifndef LINUX_MOD_DEVICETABLE_H
#define LINUX_MOD_DEVICETABLE_H

#include <linux/types.h>

typedef unsigned long kernel_ulong_t;

#define PCI_ANY_ID (~0)

struct pci_device_id {
	__u32 vendor;				// Vendor ID.
	__u32 device;				// Device ID or PCI_ANY_ID.
	__u32 subvendor;			// Subsystem ID or PCI_ANY_ID.
	__u32 subdevice;			// 
	__u32 class;				// (class,subclass,prog-if) triplet.
	__u32 class_mask;			// 
	kernel_ulong_t driver_data;	// Data private to the driver.
};


#endif /* LINUX_MOD_DEVICETABLE_H */
